DIPlib Documentation - ©1995-2013 Quantitative Imaging Group, Delft University of Technology.

# GeneralisedKuwaharaImproved

Generalised Kuwahara filter

## SYNOPSIS

`#include "dip_filtering.h"`

dip_Error dip_GeneralisedKuwaharaImproved ( in, selection, out, se, boundary, param, shape, threshold, minimum )

## DATA TYPES

binary, integer, float

## FUNCTION

This function implements an improved version of `GeneralisedKuwahara`, see that function's description for more information. This function adds a `threshold` parameter that avoids false edges in uniform regions. If the difference between maximal and minimal values within the filter window is smaller or equal to `threshold`, the centre pixel is taken, instead of the minimum (or maximum). Setting `threshold` to zero yields the same result as `GeneralisedKuwahara`.

Only the rectangular, elliptic and diamond filter shapes are supported (`DIP_FLT_SHAPE_RECTANGULAR`, `DIP_FLT_SHAPE_ELLIPTIC` and `DIP_FLT_SHAPE_DIAMOND`). Other filter shapes can be implemented by setting `shape` to `DIP_FLT_SHAPE_STRUCTURING_ELEMENT`, and passing a binary image in `se`. The "on" pixels define the shape of the filter window. Other values of `shape` are illegal.

If `shape` is not equal to `DIP_FLT_SHAPE_STRUCTURING_ELEMENT`, `se` can be set to zero. When `shape` is set to `DIP_FLT_SHAPE_STRUCTURING_ELEMENT`, `param` is ignored, and can be set to zero.

## ARGUMENTS

Data type | Name | Description
`dip_Image` | `in` | Input
`dip_Image` | `selection` | Selection
`dip_Image` | `out` | Output
`dip_Image` | `se` | Custom filter window (binary)
`dip_BoundaryArray` | `boundary` | Boundary conditions
`dip_FloatArray` | `param` | Filter sizes
`dip_FilterShape` | `shape` | Filter shape
`dip_float` | `threshold` | Minimal value difference within window
`dip_Boolean` | `minimum` | Select minimum or maximum?

The enumerator `dip_FilterShape` contains the following constants:

Name | Description
`DIP_FLT_SHAPE_DEFAULT` | Default filter window, same as `DIP_FLT_SHAPE_RECTANGULAR`
`DIP_FLT_SHAPE_RECTANGULAR` | Rectangular filter window, can be even in size
`DIP_FLT_SHAPE_ELLIPTIC` | Elliptic filter window, always odd in size
`DIP_FLT_SHAPE_DIAMOND` | Diamond-shaped filter window, always odd in size
`DIP_FLT_SHAPE_PARABOLIC` | Parabolic filter window (morphology only)
`DIP_FLT_SHAPE_DISCRETE_LINE` | Rotated line structuring element (morphology only)
`DIP_FLT_SHAPE_INTERPOLATED_LINE` | Rotated line structuring element, through interpolation (morphology only)
`DIP_FLT_SHAPE_PERIODIC_LINE` | (not implemented)
`DIP_FLT_SHAPE_STRUCTURING_ELEMENT` | Use `se` as filter window, can be any size

## SEE ALSO

`Kuwahara`, `GeneralisedKuwahara`, `KuwaharaImproved`, `VarianceFilter`, `Uniform`